#pragma config WDT = OFF	// pas de watchdog
#pragma config OSC = HS		// HS pour un quartz 20 Mhz

#include <p18f452.h>		// librairie du PIC
#include "GameGirl.h"		// inclure la librairie GameGirl.h
#include "LCD.h"			// librairie du LCD

#include <delays.h>			// librairie de temporisation

void main(void)
{
	int x=64, y=32,i;							// coordonnes de la Position initial du viseur
	unsigned int temps=0;
	unsigned char A1=20,B1=10,A2=110,B2=30;		// coodonnes des dparts des Cibles
	unsigned char NbCibles=0,tirs=0,TirsReussis=0,Balles=7,Score=0;		// noms explicites
	unsigned char C1=0,C2=0;					// 0=Cible manque / 1=Cible atteinte
	unsigned char Vitesse=0;					// Vitesse de dfilement des cibles

	unsigned char Titre[8]={'-','S','H','O','O','T','E','R'};
	unsigned char Auteur[8]={' ',' ','J','u','L','S',' ',' '};
	unsigned char Ref[8]={'2','K','7',' ','V','1','.','0'};

	unsigned char Cibles[8]={'C','i','b','l','e','s',' ',':'};
	unsigned char Tirs[8]={'T','i','r','s',' ',' ',' ',':'};
	unsigned char TirsOK[8]={'T','i','r','s',' ','O','K',':'};
	unsigned char SCORE[8]={'S','C','O','R','E',' ',' ',':'};

	unsigned char Next[8]={'V','E','R','T',' ','N','X','T'};

	unsigned char BLEU[8]={'B','l','u','e',' ','T','I','R'};
	unsigned char ROUGE[8]={'R',' ','R','c','h','a','r','g'};

	unsigned char V1[8]={'B','-','>','V','i','t',' ','1'};

	ConfigProcessor();		// Config du C
	LCD_Init();				// Initialisation du LCD
	LCD_BackLight=1;		// Activer le Rtro clairage
	LCD_Clear();			// Effacer le LCD

	TraceLigneH(12,0,128);	// Trace une ligne Horizontale
	TraceLigneH(38,0,128);	// idem

	LCD_GotoXY(10,3);
	for(i=0;i!=8;i++)
	LCD_Putchar(Titre[i]);	// Affiche le Titre

	LCD_GotoXY(80,5);
	for(i=0;i!=8;i++)
	LCD_Putchar(Auteur[i]);	// Affiche l'auteur

	LCD_GotoXY(80,6);
	for(i=0;i!=8;i++)
	LCD_Putchar(Ref[i]);	// Affiche la rfrence

	LCD_GotoXY(10,7);
	for(i=0;i!=8;i++)
	LCD_Putchar(Next[i]);	// Indique d'appuyer sur Bp Vert pour passer

	while(!Button_Green);
	while(Button_Green);	// Attendre tant que Bp Vert n'est pas appuy

	LCD_Clear();

	LCD_GotoXY(2,1);
	for(i=0;i!=8;i++)
	LCD_Putchar(BLEU[i]);	// Indique BP bleu pour tirer

	LCD_GotoXY(2,2);
	for(i=0;i!=8;i++)
	LCD_Putchar(ROUGE[i]);	// Indique BP bleu pour recharger

	LCD_GotoXY(2,4);
	for(i=0;i!=8;i++)
	LCD_Putchar(V1[i]);		// Indique BP bleu pour Choisir la vitesse 1

	LCD_GotoXY(2,5);
	LCD_Putchar('V');		// Indique BP bleu pour Choisir la vitesse 2
	LCD_GotoXY(43,5);
	LCD_Putchar('2');

	LCD_GotoXY(2,6);
	LCD_Putchar('J');		// Indique BP bleu pour Choisir la vitesse 3
	LCD_GotoXY(43,6);
	LCD_Putchar('3');

		do
		{
			if (!Button_Blue)		// Appui sur Bp Bleu pour choisir la vitesse 1
			Vitesse=1;
			if (!Button_Green)
			Vitesse=2;
			if (!Button_Yellow)
			Vitesse=3;
		}
		while (Vitesse==0);

	LCD_Clear();

	TraceLigneH(0,0,128);	// Tracer un cadre
	TraceLigneH(54,0,128);	// ...
	TraceLigneV(0,0,54);	// ...
	TraceLigneV(127,0,54);	// ...

	LCD_GotoXY(0,7);
	for(i=0;i!=5;i++)
	LCD_Putchar(Tirs[i]);	// Affiche "Tirs :" en bas a gauche du LCD

	while(1)
	{
		if (Joystick_X()>200)
		{
		EffaceViseur(x,y);
		x=x-4;				// Dplace le curseur en X de -4
		}

		if (Joystick_X()<-200)
		{
		EffaceViseur(x,y);
		x=x+4;
		}

		if (Joystick_Y()>200)
		{
		EffaceViseur(x,y);
		y=y-4;				// ... en Y
		}

		if (Joystick_Y()<-200)
		{
		EffaceViseur(x,y);
		y=y+4;
		}

		if(x<6) x=6;				// Vrifie que le curseur ne sort pas de l'cran en X
		if(x>124) x=124;
		if(y<4) y=4;				// idem en Y
		if(y>50) y=50;

		if (!Button_Blue)			// Bouton de TIR
		{
			if(Balles>0)			// Si le chargeur n'est pas vide
			{
				tirs++;				// Incrmenter le nombre de tirs
				AfficheTir(x,y);	// Afficher le tir
				Delay10KTCYx(100);	// Tempo

				if(((x>=A1) && (x<=(A1+8))) && ((y>=B1) && (y<=(B1+8))))	// Tester le tir avec
				{															// les coordonnes de la cible 1
				TirsReussis++;			// Si le tir est bon, Incrmenter le nombre de TirsReussis
				C1=1;					// Indiquer 1 = Cible atteinte
				}

				if(((x>=A2) && (x<=(A2+8))) && ((y>=B2) && (y<=(B2+8))))	// Tester le tir avec
				{															// les coordonnes de la cible 2
				TirsReussis++;			// Si le tir est bon, Incrmenter le nombre de TirsReussis
				C2=1;					// Indiquer 1 = Cible atteinte
				}
				EffaceTir(x,y);			// Effacer le TIR
			}
			if (Balles!=0)				// Si le chargeur n'est pas vide
			Balles--;					// dcrmenter le nombre de balles

		}
		
		if (!Button_Red)				// Bouton pour recharger
		{
		Balles=7;
		}
		
		if (C1==1)				// Si la Cible 1 est atteinte
		{
		EffaceCible(A1,B1);		// Effacer la cible 1
		A1=10;					// Rinitialiser la position de la cible suivante
		AfficheCible(A1,B1);	// Affiche la cible suivante
		C1=0;					// Rinitialiser la variable de cible atteinte
		NbCibles++;				// Incrmenter le nombre de Cible passes
		}
		else
		{
		EffaceCible(A1,B1);		// Effacer la cible 1
			if (A1>100)			// Si la cible 1 arrive en fin de parcours
			{
			A1=20;				// Rinitialiser la position de la cible suivante
			NbCibles++;			// Incrmenter le nombre de Cible passes
			}
		A1=A1+Vitesse;			// Dplacer la cible 1 vers la droite
		AfficheCible(A1,B1);	// Ractualiser la position de la cible 1
		}


		/*Idem avec la cible 2 */
		if (C2==1)
		{
		EffaceCible(A2,B2);
		A2=110;B2=30;
		AfficheCible(A2,B2);
		C2=0;
		NbCibles++;
		}
		else
		{
		EffaceCible(A2,B2);
			if (A2<10)
			{
			A2=100;
			NbCibles++;
			}
		A2=A2-(Vitesse+1);			// Dplacer la cible 2 vers la gauche
		AfficheCible(A2,B2);
		}

		AfficheViseur(x,y);			// Ractualiser la position du viseur	

		LCD_GotoXY(40,7);			// Affiche le nombre de Tirs en ASCII
		LCD_Putchar(((tirs/10)%10)+'0');
		LCD_GotoXY(48,7);
		LCD_Putchar((tirs%10)+'0');

		LCD_GotoXY(100,7);			// Affiche le nombre de balles en ASCII
		LCD_Putchar(Balles+'0');

		if(temps<150)				// Tempo -pas prcise-
		temps++;
		else
		{
		LCD_Clear();

		LCD_GotoXY(10,2);
		for(i=0;i!=8;i++)
		LCD_Putchar(Cibles[i]);			// Affiche "Cibles :"

		LCD_GotoXY(88,2); 				// Affiche le nombre de Cibles passes en ASCII
		LCD_Putchar(((NbCibles/10)%10)+'0');
		LCD_GotoXY(96,2);
		LCD_Putchar((NbCibles%10)+'0');

		LCD_GotoXY(10,3);
		for(i=0;i!=8;i++)
		LCD_Putchar(Tirs[i]);			// Affiche "Tirs :"

		LCD_GotoXY(88,3); 				// Affiche le nombre de Tirs en ASCII
		LCD_Putchar(((tirs/10)%10)+'0');
		LCD_GotoXY(96,3);
		LCD_Putchar((tirs%10)+'0');

		LCD_GotoXY(10,4);
		for(i=0;i!=8;i++)
		LCD_Putchar(TirsOK[i]);					// Affiche "Tirs OK :"

		LCD_GotoXY(88,4);
		LCD_Putchar(((TirsReussis/10)%10)+'0'); // Affiche le nombre de TirsReussis en ASCII
		LCD_GotoXY(96,4);
		LCD_Putchar((TirsReussis%10)+'0');

		Score=(NbCibles+tirs)*TirsReussis;		// Calculer le score

		LCD_GotoXY(10,6);
		for(i=0;i!=8;i++)
		LCD_Putchar(SCORE[i]);					// Affiche "SCORE :"

		LCD_GotoXY(80,6); 						// Affiche le SCORE en ASCII
		LCD_Putchar(((Score/100)+'0'));			// Affiche les centaines en ASCII
		LCD_GotoXY(88,6);
		LCD_Putchar(((Score/10)%10)+'0'); 		// Affiche les dizaines en ASCII
		LCD_GotoXY(96,6);
		LCD_Putchar((Score%10)+'0'); 			// Affiche les units en ASCII

		while(!Button_Yellow);			// Attendre tant que Bp Vert n'est pas appuy
		while(Button_Yellow);			// Pour recommencer la partie

		LCD_Clear();
		}

		Delay10KTCYx(10);			// Tempo
	}
}
