#pragma config WDT = OFF	// pas de watchdog
#pragma config OSC = HS		// HS pour un quartz 20 Mhz

#include <p18f452.h>		// librairie du PIC
#include "GameGirl.h"		// inclure la librairie GameGirl.h
#include "LCD.h"			// librairie du LCD

#include <delays.h>			// librairie de temporisation


void main(void)
{
	int x=64, y=32,i;							// coordonnes de la Position initial du viseur
	unsigned int temps=0;				// temps de la partie
	unsigned char A1=20,B1=10,A2=110,B2=30;		// coordonnes des positions initiales des Cibles
	unsigned char NbCibles=0,tirs=0,TirsReussis=0,Balles=7,Score=0;		// noms explicites
	unsigned char C1=0,C2=0;					// 0=Cible manque / 1=Cible atteinte
	unsigned char Vitesse=0;					// Vitesse de dfilement des cibles

	unsigned char Titre[8]={'-','S','H','O','O','T','E','R'};
	unsigned char Auteur[8]={' ',' ','J','u','L','S',' ',' '};
	unsigned char Ref[8]={'2','K','7',' ','V','1','.','0'};
	unsigned char Cibles[8]={'C','i','b','l','e','s',' ',':'};
	unsigned char Tirs[8]={'T','i','r','s',':',' ',' ',' '};
	unsigned char TirsOK[8]={'T','i','r','s',' ','O','K',':'};
	unsigned char SCORE[8]={'S','C','O','R','E',' ',' ',':'};
	unsigned char Next[8]={'V','E','R','T',' ','N','X','T'};
	unsigned char BLEU[8]={'B','l','u','e',' ','T','I','R'};
	unsigned char ROUGE[8]={'R',' ','R','c','h','a','r','g'};
	unsigned char V1[8]={'B','-','>','V','i','t',' ','1'};

	ConfigProcessor();		// Config du C
	LCD_Init();				// Initialisation du LCD
	LCD_BackLight=1;		// Activer le Rtro clairage
	LCD_Clear();			// Effacer le LCD

	/************ INTRODUCTION DU JEU ************/
	AfficheIntro(Titre, Auteur, Ref, Next);			// Afficher l'Ecran d'Introduction " SHOOTER ... "

	while(!Button_Green);
	while(Button_Green);	// Attendre tant que Bp Vert n'est pas appuy

	LCD_Clear();		// Effacer le LCD

	/************ AFFICHAGE DES COMMANDES ET DU CHOIX DE LA VITESSE ************/
	AfficheCommand_V(BLEU, ROUGE, V1);		// Afficher  l'Ecran "Blue Tir - R Recharg ..."
	Vitesse = ChoixVitesse();			// Choix de la vitesse


	/************ DEBUT DE LA PARTIE ************/
	LCD_Clear();				// Effacer le LCD

	AffCadres_Tirs(Tirs);			// Affiche les Cadres et "Tirs :" en bas a gauche

	while(1)				// Boucle Infini
	{

	/************ GERER LES DEPLACEMENTS DU VISEUR ************/
		if (Joystick_X()>200)	// Si le Joystick est actionner
		{
		EffaceViseur(x,y);		// Effacer la position actuel du viseur
		x=x-4;					// Dplace le curseur en X de -4
		}

		if (Joystick_X()<-200)
		{
		EffaceViseur(x,y);
		x=x+4;
		}

		if (Joystick_Y()>200)
		{
		EffaceViseur(x,y);
		y=y-4;				// ... en Y
		}

		if (Joystick_Y()<-200)
		{
		EffaceViseur(x,y);
		y=y+4;
		}


	/************ VERIFIER QUE LE VISEUR RESTE DANS L'ECRAN DE JEU ************/
		if(x<6) x=6;				// Vrifie que le curseur ne sort pas de l'cran en X
		if(x>124) x=124;
		if(y<4) y=4;				// idem en Y
		if(y>50) y=50;


	/************ COMMANDE DE TIR ET TEST DU TIR SUR LES CIBLES ************/
		if (!Button_Blue)			// Bouton de TIR
		{
			if(Balles>0)			// Si le chargeur n'est pas vide
			{
			tirs++;				// Incrmenter le nombre de tirs
			AfficheTir(x,y);		// Afficher le tir
			Delay10KTCYx(100);		// Tempo pour voir le tir

				if(((x>=A1) && (x<=(A1+8))) && ((y>=B1) && (y<=(B1+8))))	// Tester le tir avec
				{															// les coordonnes de la cible 1
				TirsReussis++;			// Si le tir est bon, Incrmenter le nombre de TirsReussis
				C1=1;					// Indiquer 1 = Cible 1 atteinte
				}

				if(((x>=A2) && (x<=(A2+8))) && ((y>=B2) && (y<=(B2+8))))	// Tester le tir avec
				{															// les coordonnes de la cible 2
				TirsReussis++;			// Si le tir est bon, Incrmenter le nombre de TirsReussis
				C2=1;					// Indiquer 1 = Cible 2 atteinte
				}
				EffaceTir(x,y);			// Effacer le TIR
			}
			if (Balles!=0)				// Si le chargeur n'est pas vide
			Balles--;					// dcrmenter le nombre de balles

		}


	/************ COMMANDE DE RECHARGEMENT DU PISTOLET ************/		
		if (!Button_Red)				// Bouton pour recharger
		{
		Balles=7;					// Recharger  7 balles
		}


	/************ GERER LES DEPLACEMENTS DE LA CIBLE 1 ************/
	/*** La cible 1 est en haut et se dplace vers la droite ***/			
		if (C1==1)				// Si la Cible 1 est atteinte
		{
		EffaceCible(A1,B1);		// Effacer la cible 1
		A1=10;					// Rinitialiser la position de la cible suivante
		AfficheCible(A1,B1);	// Affiche la cible suivante
		C1=0;					// Rinitialiser la variable de cible atteinte
		NbCibles++;				// Incrmenter le nombre de Cible passes
		}
		else
		{
		EffaceCible(A1,B1);		// Effacer la cible 1
			if (A1>100)			// Si la cible 1 arrive en fin de parcours
			{
			A1=20;				// Rinitialiser la position de la cible suivante
			NbCibles++;			// Incrmenter le nombre de Cible passes
			}
		A1=A1+Vitesse;			// Dplacer la cible 1 vers la droite
		AfficheCible(A1,B1);	// Ractualiser la position de la cible 1
		}


	/************GERER LES DEPLACEMENTS DE LA CIBLE 2 ************/
	/*** La cible 2 est en bas et se dplace vers la gauche ***/		
		/*** Idem avec la cible 2 ***/
		if (C2==1)
		{
		EffaceCible(A2,B2);
		A2=110;B2=30;
		AfficheCible(A2,B2);
		C2=0;
		NbCibles++;
		}
		else
		{
		EffaceCible(A2,B2);
			if (A2<10)
			{
			A2=100;
			NbCibles++;
			}
		A2=A2-(Vitesse+1);			// Dplacer la cible 2 vers la gauche plus vite que la 1
		AfficheCible(A2,B2);
		}


	/************ ACTUALISATION DU VISEUR ET DU NOMBRE DE TIRS ET BALLES  ************/	
		AfficheViseur(x,y);			// Ractualiser la position du viseur	
		AffTirs_Balles(tirs, Balles);		// Affiche le nombre de tirs et le nombre de balles restantes

	/************ GERER LA FIN DE LA PARTIE  ************/	
		if(temps<150)				// Tempo -peu prcise-
		temps++;
		else
		{
		LCD_Clear();


	/************ AFFICHER LES DIFFERENTES INFORMATIONS  ************/	
		AffNbCibles(Cibles, NbCibles);			// Afficher le nombres de cibles passes
		AffNbTirs(Tirs, tirs);			// Afficher le nombres de tirs
		AffNbTirsOK(TirsOK, TirsReussis);			// Afficher le nombres de tirs russis

		Score=(NbCibles+tirs)*TirsReussis;		// Calculer le score
		AffScore(SCORE, score);							// Afficher le score

		while(!Button_Yellow);			// Attendre tant que Bp Vert n'est pas appuy
		while(Button_Yellow);			// Pour stopper la boucle

		LCD_Clear();


		/************ REINITIALISATION DES VARIABLES ************/

		x=64; y=32;					// coordonnes de la Position initial du viseur
	 	temps=0;					// temps de la partie
		A1=20; B1=10; A2=110; B2=30;		// coordonnes des position initiales des Cibles
		NbCibles=0; tirs=0; TirsReussis=0; Balles=7; Score=0;		// noms explicites
		C1=0;C2=0;					// 0=Cible manque / 1=Cible atteinte
		Vitesse=0;					// vitesse par dfaut


		/************ NOUVELLE PARTIE ************/

		/************ AFFICHAGE DES COMMANDES ET DU CHOIX DE LA VITESSE ************/
		AfficheCommand_V(BLEU, ROUGE, V1);		// Afficher  l'Ecran "Blue Tir - R Recharg ..."
		Vitesse = ChoixVitesse();			// Choix de la vitesse

			/************ DEBUT DE LA NOUVELLE PARTIE ************/
			LCD_Clear();

			AffCadres_Tirs(Tirs);			// Affiche les Cadres et "Tirs :" en bas a gauche

		}

	Delay10KTCYx(10);		// Tempo Pour ralentir les affichages et les dplacements
	}
}
